# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from typing import List, Generic, TypeVar, Optional
from typing_extensions import override

from pydantic import Field as FieldInfo

from ._base_client import BasePage, PageInfo, BaseSyncPage, BaseAsyncPage

__all__ = ["SyncPaginatedResponse", "AsyncPaginatedResponse"]

_T = TypeVar("_T")


class SyncPaginatedResponse(BaseSyncPage[_T], BasePage[_T], Generic[_T]):
    data: List[_T]
    next_cursor: Optional[str] = FieldInfo(alias="nextCursor", default=None)
    has_more: Optional[bool] = FieldInfo(alias="hasMore", default=None)
    total: Optional[int] = None

    @override
    def _get_page_items(self) -> List[_T]:
        data = self.data
        if not data:
            return []
        return data

    @override
    def has_next_page(self) -> bool:
        has_more = self.has_more
        if has_more is not None and has_more is False:
            return False

        return super().has_next_page()

    @override
    def next_page_info(self) -> Optional[PageInfo]:
        next_cursor = self.next_cursor
        if not next_cursor:
            return None

        return PageInfo(params={"cursor": next_cursor})


class AsyncPaginatedResponse(BaseAsyncPage[_T], BasePage[_T], Generic[_T]):
    data: List[_T]
    next_cursor: Optional[str] = FieldInfo(alias="nextCursor", default=None)
    has_more: Optional[bool] = FieldInfo(alias="hasMore", default=None)
    total: Optional[int] = None

    @override
    def _get_page_items(self) -> List[_T]:
        data = self.data
        if not data:
            return []
        return data

    @override
    def has_next_page(self) -> bool:
        has_more = self.has_more
        if has_more is not None and has_more is False:
            return False

        return super().has_next_page()

    @override
    def next_page_info(self) -> Optional[PageInfo]:
        next_cursor = self.next_cursor
        if not next_cursor:
            return None

        return PageInfo(params={"cursor": next_cursor})
